<?php
/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
//
//-------------------------------------------------------
//-- HANGMAN v2.0                                      --
//-- PHP game by Giovanni Crisci                       --
//-- http://giovi.supereva.it                          --
//-- Images taken from ASP code written by             --
//-- ASP101 http://www.asp101.com                      --
//-------------------------------------------------------

//
// administration tool
//

if (!eregi("admin.php", $PHP_SELF)) { die ("Access Denied"); }
$module_name = ('hangman');
get_lang($module_name);

// shows the first part of the template

include("header.php");
GraphicAdmin();
OpenTable();
?>

<p style="font-family:Arial, Helvetica,sans-serif;font-size:28px;font-weight:bold;color:black;text-align:center">
<img src="images/admin/hangman.gif" style="width.48;height:47;vertical-align:middle"/> Hangman
</p>

<?php
CloseTable ();
// shows the main menu

   OpenTable ();
   $menuarr = array('', _HNGNUK1, _HNGNUK2, _HNGNUK3);
   $totmenu = count ($menuarr);
   $j=1;
   echo ("<p style=\"text-align:center\">|\n");
   for ($j; $j<$totmenu; $j++) {
    print (' <a href="'.$_SERVER['PHP_SELF'].'?op=hangman&amp;admenu='.$j.'">'.$menuarr[$j].'</a>');
    echo (" |");
   }
   echo ("</p>\n");
   CloseTable();

// if access is granted selects the option from the menu

  if (isset($_GET['admenu'])) {
   OpenTable();
   print ('<h3>'.$menuarr[$_GET['admenu']].'</h3>');
   echo ("\n");
   switch ($_GET['admenu']) {

// option 1 - add a word to the database

    case 1:
     if (isset($_POST['addword0'])) {
	  $addwordarray = array ();
	  $addcheck = false;
	  for ($l=0; $l<=9; $l++) {array_push($addwordarray, $_POST['addword'.$l]);}
	  foreach ($addwordarray as $addword) {

// the word must contain only allowed letters

       $addword = strtoupper ($addword);
       $addword = ereg_replace ("[^A-Z\-\ ]*", '', $addword);

// avoids to insert an empty word

       if ($addword=='') continue;
       else {

// avoids that a word already present is inserted again

       $result = sql_query("select id from ".$prefix."_hangman where word = '".$addword."'", $dbi);
       $riga = sql_fetch_row($result, $dbi);
        if ($riga!='') {
         print ('<p>'.$addword.' '._ALRINSRT.'</p>');
         echo ("\n");
        }
        else {

// inserts the word

         $res = sql_query("insert into ".$prefix."_hangman (word) values ('".$addword."')", $dbi);
         print ('<p>'.$addword.' '._INSRTW.'</p>');
		 $addcheck = true;
         echo ("\n");
        } 
       }
      }	
      if (!$addcheck) echo ("<p>"._NOTINSRT."</p>\n");
      print ('<p><a href="'.$_SERVER['PHP_SELF'].'?op=hangman&amp;admenu=1">'._OTHERWRD.'</a></p>');
      echo ("\n");
     }
     else {

// show to form to insert the word

      ?>
      <form method="post" action="<?=$_SERVER['PHP_SELF']; ?>?op=hangman&amp;admenu=1">
       <?=_INSWORD; ?><br />
	   <?php
	   for ($l=0; $l<=9; $l++) {
	    echo ("<input type=\"text\" name=\"addword$l\" size=\"25\" maxlength=\"25\" /><br />\n");
	   }
	   ?>
       <input type="submit" value="<?=_SBMT; ?>" name="go" />
      </form>
      <?php
     }
    break;

// option 2 - modify a word or a score

    case 2:
     if (isset($_POST['go'])) {

// modifications are posted and inserted

      for ($k=1; $k<=$_POST['fnumres']; $k++) {
       $chgword = strtoupper ($_POST['fword'.$k]);
       $chgword = ereg_replace ("[^A-Z\-\ ]*", '', $chgword);

// chances must not be more than 6

       $ftent = min ($_POST['ftent'.$k], 6);
       $res = sql_query("update ".$prefix.
        "_hangman set word = '".$chgword."', best = '".$_POST['fbest'.$k].
        "', errors = '".$ftent."', time = '".$_POST['ftime'.$k].
        "' where id = ".$_POST['fid'.$k], $dbi);
      }
      echo ("<p>"._DATAUP."</p>\n");
     }

// shows the words and lets edit them

     $result = sql_query("select * from ".$prefix."_hangman order by word", $dbi);
     if (isset($_GET['from'])) $from = $_GET['from'];
      else $from = 0;
     echo ("<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?op=hangman&amp;admenu=2&amp;from=".$from."\">\n");
     echo (" <table width=\"100%\">\n  <tr>\n   <td>"._WRD."</td>\n   <td>".
      _BST."</td>\n   <td>"._TNT."</td>\n   <td>"._TME."</td>\n  </tr>\n");

// chooses the range from which the words are taken for editing

     $res_per_page = 20;
     $to = $from + $res_per_page - 1;
     $numres = 0;
     if ($from>0) {
      foreach (range(0, $from) as $rownum) {
       if (!$riga = sql_fetch_row($result, $dbi)) break;
      }
	 }
     foreach (range($from, $to) as $rownum) {
      if (!$riga = sql_fetch_row($result, $dbi)) break;
      $numres++;
      echo ("  <tr>\n   <td><input type=\"hidden\" name=\"fid".$numres."\" value=\"".
       $riga[0]."\" /><input type=\"text\" name=\"fword".$numres."\" value=\"".
       $riga[1]."\" size=\"25\" maxlength=\"25\" /></td>\n   <td><input type=\"text\" name=\"fbest".
       $numres."\" value=\"".$riga[2]."\" size=\"15\" maxlength=\"15\" /></td>\n   <td><input type=\"text\" name=\"ftent".
       $numres."\" value=\"".$riga[3]."\" size=\"2\" maxlength=\"1\" /></td>\n   <td><input type=\"text\" name=\"ftime".
       $numres."\" value=\"".$riga[4]."\" size=\"4\" maxlength=\"3\" /></td>\n   <td>\n  </tr>\n");
     }
     echo (" </table>\n");
     echo (" <input type=\"hidden\" name=\"fnumres\" value=\"".$numres."\" />\n");
     echo (" <input type=\"submit\" value=\""._SBMT."\" name=\"go\" />\n");
     echo ("</form>\n");
     $numrighe = sql_num_rows($result);

// navigation bar

     if ($numrighe>$res_per_page) {
      echo ("<p>\n");
      if ($from>0) {
       print (' <a href="'.$_SERVER['PHP_SELF'].'?op=hangman&amp;admenu=2&amp;from='.max($from - $res_per_page, 0).'">'._LPRV.'</a>');
       echo ("\n");
      }
      if ($to<$numrighe) {
       print (' <a href="'.$_SERVER['PHP_SELF'].'?op=hangman&amp;admenu=2&amp;from='.($from + $res_per_page).'">'._LNXT.'</a>');
       echo ("\n");
      }
      echo ("</p>\n");
     }
     echo ("\n");
     
    break;

// option 3 - delete a word or a score

    case 3:
     if (isset($_GET['from'])) $from = $_GET['from'];
      else $from = 0;
     if (isset($_POST['go'])) {

// checks if words/scores to be deleted were chosen

      if ($_POST['go']==_SBMT) {
       echo ("<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?op=hangman&amp;admenu=3&amp;from=".$from."\">\n");
       $controllo = false;
       for ($k=1; $k<=$_POST['fnumres']; $k++) {
        if ($_POST['fdel'.$k]!='off') $controllo=true;
       }
       if ($controllo) {

// asks confirmation for deletion

        $erword = "";
        $erscore = "";
        echo (" <input type=\"hidden\" name=\"fnumres\" value=\"".$_POST['fnumres']."\" />\n");
        for ($k=1; $k<=$_POST['fnumres']; $k++) {
         if ($_POST['fdel'.$k]=='all') {
          echo (" <input type=\"hidden\" name=\"fdel".$k."\" value=\"all\" />\n");
          echo (" <input type=\"hidden\" name=\"fid".$k."\" value=\"".$_POST['fid'.$k]."\" />\n");
          $erword.= ("  ".$_POST['fword'.$k]."<br />\n");
         }
         if ($_POST['fdel'.$k]=='score') {
          echo (" <input type=\"hidden\" name=\"fdel".$k."\" value=\"score\" />\n");
          echo (" <input type=\"hidden\" name=\"fid".$k."\" value=\"".$_POST['fid'.$k]."\" />\n");
          $erscore.= ("  ".$_POST['fword'.$k]."<br />\n");
         }
        }
       echo (" <p>\n  "._CNFRWORD."<br />\n".$erword);
       if ($erword=="") echo (" -----<br />\n");
       echo ("  "._CNFRSCORE."<br />\n".$erscore);
       if ($erscore=="") echo (" -----<br />\n");
       echo (" </p>\n");
       echo (" <input type=\"submit\" value=\""._CNFRYES."\" name=\"go\" />\n");
       }
       else echo ("<p>"._NTHGDO."</p>\n"); 
       echo (" <input type=\"submit\" value=\""._BTTBACK."\" name=\"back\" />\n");
       echo ("</form>\n");
      }
      if ($_POST['go']==_CNFRYES) {

// deletion confirmed - words/scores are deleted

       $contrtable = false;
       for ($k=1; $k<=$_POST['fnumres']; $k++) {
        if (isset($_POST['fdel'.$k])) {
         if ($_POST['fdel'.$k]=="all") {
          $res = sql_query("delete from ".$prefix.
           "_hangman where id = ".$_POST['fid'.$k]." limit 1", $dbi);
          $contrtable = true;
         }
         if ($_POST['fdel'.$k]=="score") {
          $res = sql_query("update ".$prefix.
           "_hangman set best = '', errors = 6, time = '' where id = ".
           $_POST['fid'.$k], $dbi);
         }
        }
       }

// repair id column after deletion

       if ($contrtable) {
        $res = sql_query("alter table ".$prefix."_hangman drop id ", $dbi);
        $res = sql_query("alter table ".$prefix."_hangman add id ".
         "int unsigned not null auto_increment primary key first", $dbi); 
       }
       echo ("<p>"._DATAUP."</p>\n");
      }
     }

// shows words and lets choose what to do

     if (!isset($controllo)) {
      $result = sql_query("select * from ".$prefix."_hangman order by word", $dbi);
      echo ("<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?op=hangman&amp;admenu=3&amp;from=".$from."\">\n");
      echo (" <table width=\"100%\">\n  <tr>\n   <td>"._WRD."</td>\n   <td>".
       _BST."</td>\n   <td>"._TNT."</td>\n   <td>"._TME."</td>\n   <td>".
       _DLTWRD."</td>\n   <td>"._DLTSCR."</td>\n   <td>"._DONTHG."</td>\n  </tr>\n");

// chooses the range from which the words are taken for editing

      $res_per_page = 20;
      $to = $from + $res_per_page - 1;
      $numres = 0;
      if ($from>0) {
       foreach (range(0, $from) as $rownum) {
        if (!$riga = sql_fetch_row($result, $dbi)) break;
       }
	  }
      foreach (range($from, $to) as $rownum) {
       if (!$riga = sql_fetch_row($result, $dbi)) break;
       $numres++;
       echo ("  <tr>\n   <td><input type=\"hidden\" name=\"fid".$numres."\" value=\"".
        $riga[0]."\" /><input type=\"hidden\" name=\"fword".$numres."\" value=\"".$riga[1].
        "\" />".$riga[1]."</td>\n   <td>".$riga[2]."</td>\n   <td>".
        $riga[3]."</td>\n   <td>".$riga[4]."</td>\n   <td>".
        "<input type=\"radio\" name=\"fdel".$numres."\" value=\"all\" /></td>\n".
        "   <td><input type=\"radio\" name=\"fdel".$numres."\" value=\"score\" />".
        "</td>\n   <td><input type=\"radio\" name=\"fdel".$numres."\" value=\"off".
        "\" checked /></td>\n  </tr>\n");
      }
      echo (" </table>\n");
      echo (" <input type=\"hidden\" name=\"fnumres\" value=\"".$numres."\" />\n");
      echo (" <input type=\"submit\" value=\""._SBMT."\" name=\"go\" />\n");
      echo ("</form>\n");
      $numrighe = sql_num_rows($result);

// navigation bar

      if ($numrighe>$res_per_page) {
       echo ("<p>\n");
       if ($from>0) {
        print (' <a href="'.$_SERVER['PHP_SELF'].'?op=hangman&amp;admenu=3&amp;from='.max($from - $res_per_page, 0).'">'._LPRV.'</a>');
        echo ("\n");
       }
       if ($to<$numrighe) {
        print (' <a href="'.$_SERVER['PHP_SELF'].'?op=hangman&amp;admenu=3&amp;from='.($from + $res_per_page).'">'._LNXT.'</a>');
        echo ("\n");
       }
       echo ("</p>\n");
      }
      echo ("\n");
     }
     break;

   }
   CloseTable();
  }
  else {
   $result = sql_query("select * from ".$prefix."_hangman", $dbi);
   if (!$result) {
   $creatable = "CREATE TABLE ".$prefix."_hangman (
    id int(10) unsigned NOT NULL auto_increment,
    word varchar(32) NOT NULL default '',
    best varchar(15) NOT NULL default '',
    errors tinyint(3) unsigned NOT NULL default '6',
    time int(11) unsigned NOT NULL default '0',
    PRIMARY KEY  (id)
    ) TYPE=MyISAM;";
   $result = sql_query($creatable, $dbi);
   }
  }

// shows the final part of the template

include("footer.php");

?>